---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for Pulse generation control registers
---------------------------------------------------------------------------------------
-- File           : pgen_ctrl_regs.vhd
-- Author         : auto-generated by wbgen2 from pgen_ctrl_regs.wb
-- Created        : Fri Aug 16 11:22:20 2013
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE pgen_ctrl_regs.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity pgen_ctrl_regs is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(4 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
-- Port for std_logic_vector field: 'channel enable' in reg: 'Enable register'
    pgen_ctrl_regs_en_ch_o                   : out    std_logic_vector(5 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH1 delay register'
    pgen_ctrl_regs_ch1_delay_bits_o          : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH2 delay register'
    pgen_ctrl_regs_ch2_delay_bits_o          : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH3 delay register'
    pgen_ctrl_regs_ch3_delay_bits_o          : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH4 delay register'
    pgen_ctrl_regs_ch4_delay_bits_o          : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH5 delay register'
    pgen_ctrl_regs_ch5_delay_bits_o          : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH6 delay register'
    pgen_ctrl_regs_ch6_delay_bits_o          : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH1 pulse width register'
    pgen_ctrl_regs_ch1_pwidth_bits_o         : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH2 pulse width register'
    pgen_ctrl_regs_ch2_pwidth_bits_o         : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH3 pulse width register'
    pgen_ctrl_regs_ch3_pwidth_bits_o         : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH4 pulse width register'
    pgen_ctrl_regs_ch4_pwidth_bits_o         : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH5 pulse width register'
    pgen_ctrl_regs_ch5_pwidth_bits_o         : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH6 pulse width register'
    pgen_ctrl_regs_ch6_pwidth_bits_o         : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH1 frequency register'
    pgen_ctrl_regs_ch1_freq_bits_o           : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH2 frequency register'
    pgen_ctrl_regs_ch2_freq_bits_o           : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH3 frequency register'
    pgen_ctrl_regs_ch3_freq_bits_o           : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH4 frequency register'
    pgen_ctrl_regs_ch4_freq_bits_o           : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH5 frequency register'
    pgen_ctrl_regs_ch5_freq_bits_o           : out    std_logic_vector(31 downto 0);
-- Port for std_logic_vector field: 'bits' in reg: 'CH6 frequency register'
    pgen_ctrl_regs_ch6_freq_bits_o           : out    std_logic_vector(31 downto 0)
  );
end pgen_ctrl_regs;

architecture syn of pgen_ctrl_regs is

signal pgen_ctrl_regs_en_ch_int                 : std_logic_vector(5 downto 0);
signal pgen_ctrl_regs_ch1_delay_bits_int        : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch2_delay_bits_int        : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch3_delay_bits_int        : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch4_delay_bits_int        : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch5_delay_bits_int        : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch6_delay_bits_int        : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch1_pwidth_bits_int       : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch2_pwidth_bits_int       : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch3_pwidth_bits_int       : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch4_pwidth_bits_int       : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch5_pwidth_bits_int       : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch6_pwidth_bits_int       : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch1_freq_bits_int         : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch2_freq_bits_int         : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch3_freq_bits_int         : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch4_freq_bits_int         : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch5_freq_bits_int         : std_logic_vector(31 downto 0);
signal pgen_ctrl_regs_ch6_freq_bits_int         : std_logic_vector(31 downto 0);
signal ack_sreg                                 : std_logic_vector(9 downto 0);
signal rddata_reg                               : std_logic_vector(31 downto 0);
signal wrdata_reg                               : std_logic_vector(31 downto 0);
signal bwsel_reg                                : std_logic_vector(3 downto 0);
signal rwaddr_reg                               : std_logic_vector(4 downto 0);
signal ack_in_progress                          : std_logic      ;
signal wr_int                                   : std_logic      ;
signal rd_int                                   : std_logic      ;
signal allones                                  : std_logic_vector(31 downto 0);
signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_dat_i;
  bwsel_reg <= wb_sel_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      pgen_ctrl_regs_en_ch_int <= "000000";
      pgen_ctrl_regs_ch1_delay_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch2_delay_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch3_delay_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch4_delay_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch5_delay_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch6_delay_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch1_pwidth_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch2_pwidth_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch3_pwidth_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch4_pwidth_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch5_pwidth_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch6_pwidth_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch1_freq_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch2_freq_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch3_freq_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch4_freq_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch5_freq_bits_int <= "00000000000000000000000000000000";
      pgen_ctrl_regs_ch6_freq_bits_int <= "00000000000000000000000000000000";
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          ack_in_progress <= '0';
        else
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(4 downto 0) is
          when "00000" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_en_ch_int <= wrdata_reg(5 downto 0);
            end if;
            rddata_reg(5 downto 0) <= pgen_ctrl_regs_en_ch_int;
            rddata_reg(6) <= 'X';
            rddata_reg(7) <= 'X';
            rddata_reg(8) <= 'X';
            rddata_reg(9) <= 'X';
            rddata_reg(10) <= 'X';
            rddata_reg(11) <= 'X';
            rddata_reg(12) <= 'X';
            rddata_reg(13) <= 'X';
            rddata_reg(14) <= 'X';
            rddata_reg(15) <= 'X';
            rddata_reg(16) <= 'X';
            rddata_reg(17) <= 'X';
            rddata_reg(18) <= 'X';
            rddata_reg(19) <= 'X';
            rddata_reg(20) <= 'X';
            rddata_reg(21) <= 'X';
            rddata_reg(22) <= 'X';
            rddata_reg(23) <= 'X';
            rddata_reg(24) <= 'X';
            rddata_reg(25) <= 'X';
            rddata_reg(26) <= 'X';
            rddata_reg(27) <= 'X';
            rddata_reg(28) <= 'X';
            rddata_reg(29) <= 'X';
            rddata_reg(30) <= 'X';
            rddata_reg(31) <= 'X';
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00001" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch1_delay_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch1_delay_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00010" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch2_delay_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch2_delay_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00011" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch3_delay_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch3_delay_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00100" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch4_delay_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch4_delay_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00101" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch5_delay_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch5_delay_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00110" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch6_delay_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch6_delay_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "00111" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch1_pwidth_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch1_pwidth_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01000" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch2_pwidth_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch2_pwidth_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01001" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch3_pwidth_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch3_pwidth_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01010" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch4_pwidth_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch4_pwidth_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01011" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch5_pwidth_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch5_pwidth_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01100" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch6_pwidth_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch6_pwidth_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01101" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch1_freq_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch1_freq_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01110" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch2_freq_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch2_freq_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "01111" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch3_freq_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch3_freq_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10000" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch4_freq_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch4_freq_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10001" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch5_freq_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch5_freq_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when "10010" => 
            if (wb_we_i = '1') then
              pgen_ctrl_regs_ch6_freq_bits_int <= wrdata_reg(31 downto 0);
            end if;
            rddata_reg(31 downto 0) <= pgen_ctrl_regs_ch6_freq_bits_int;
            ack_sreg(0) <= '1';
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Drive the data output bus
  wb_dat_o <= rddata_reg;
-- channel enable
  pgen_ctrl_regs_en_ch_o <= pgen_ctrl_regs_en_ch_int;
-- bits
  pgen_ctrl_regs_ch1_delay_bits_o <= pgen_ctrl_regs_ch1_delay_bits_int;
-- bits
  pgen_ctrl_regs_ch2_delay_bits_o <= pgen_ctrl_regs_ch2_delay_bits_int;
-- bits
  pgen_ctrl_regs_ch3_delay_bits_o <= pgen_ctrl_regs_ch3_delay_bits_int;
-- bits
  pgen_ctrl_regs_ch4_delay_bits_o <= pgen_ctrl_regs_ch4_delay_bits_int;
-- bits
  pgen_ctrl_regs_ch5_delay_bits_o <= pgen_ctrl_regs_ch5_delay_bits_int;
-- bits
  pgen_ctrl_regs_ch6_delay_bits_o <= pgen_ctrl_regs_ch6_delay_bits_int;
-- bits
  pgen_ctrl_regs_ch1_pwidth_bits_o <= pgen_ctrl_regs_ch1_pwidth_bits_int;
-- bits
  pgen_ctrl_regs_ch2_pwidth_bits_o <= pgen_ctrl_regs_ch2_pwidth_bits_int;
-- bits
  pgen_ctrl_regs_ch3_pwidth_bits_o <= pgen_ctrl_regs_ch3_pwidth_bits_int;
-- bits
  pgen_ctrl_regs_ch4_pwidth_bits_o <= pgen_ctrl_regs_ch4_pwidth_bits_int;
-- bits
  pgen_ctrl_regs_ch5_pwidth_bits_o <= pgen_ctrl_regs_ch5_pwidth_bits_int;
-- bits
  pgen_ctrl_regs_ch6_pwidth_bits_o <= pgen_ctrl_regs_ch6_pwidth_bits_int;
-- bits
  pgen_ctrl_regs_ch1_freq_bits_o <= pgen_ctrl_regs_ch1_freq_bits_int;
-- bits
  pgen_ctrl_regs_ch2_freq_bits_o <= pgen_ctrl_regs_ch2_freq_bits_int;
-- bits
  pgen_ctrl_regs_ch3_freq_bits_o <= pgen_ctrl_regs_ch3_freq_bits_int;
-- bits
  pgen_ctrl_regs_ch4_freq_bits_o <= pgen_ctrl_regs_ch4_freq_bits_int;
-- bits
  pgen_ctrl_regs_ch5_freq_bits_o <= pgen_ctrl_regs_ch5_freq_bits_int;
-- bits
  pgen_ctrl_regs_ch6_freq_bits_o <= pgen_ctrl_regs_ch6_freq_bits_int;
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (wb_stb_i and wb_cyc_i);
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
